package ext {
import ext.mixin.Observable;

[Native]
/**
 * @see ext.events.GlobalEvents_componentEvent.ADDED
 * @eventType ext.events.GlobalEvents_componentEvent.ADDED
 */
[Event(name = 'onAdded', type = 'ext.events.GlobalEvents_componentEvent')]
/**
 * @see ext.events.GlobalEvents_contextEvent.BEFORE_RESPONSIVE_UPDATE
 * @eventType ext.events.GlobalEvents_contextEvent.BEFORE_RESPONSIVE_UPDATE
 */
[Event(name = 'onBeforeResponsiveUpdate', type = 'ext.events.GlobalEvents_contextEvent')]
/**
 * @see ext.events.GlobalEvents_route_actionEvent.BEFORE_ROUTE
 * @eventType ext.events.GlobalEvents_route_actionEvent.BEFORE_ROUTE
 */
[Event(name = 'onBeforeRoute', type = 'ext.events.GlobalEvents_route_actionEvent')]
/**
 * @see ext.events.GlobalEvents_action_routeEvent.BEFORE_ROUTE_EXIT
 * @eventType ext.events.GlobalEvents_action_routeEvent.BEFORE_ROUTE_EXIT
 */
[Event(name = 'onBeforeRouteExit', type = 'ext.events.GlobalEvents_action_routeEvent')]
/**
 * @see ext.events.GlobalEvents_action_tokensEvent.BEFORE_ROUTES
 * @eventType ext.events.GlobalEvents_action_tokensEvent.BEFORE_ROUTES
 */
[Event(name = 'onBeforeRoutes', type = 'ext.events.GlobalEvents_action_tokensEvent')]
/**
 * @see ext.events.GlobalEvents_contextEvent.BEGIN_RESPONSIVE_UPDATE
 * @eventType ext.events.GlobalEvents_contextEvent.BEGIN_RESPONSIVE_UPDATE
 */
[Event(name = 'onBeginResponsiveUpdate', type = 'ext.events.GlobalEvents_contextEvent')]
/**
 * @see ext.events.GlobalEvents_componentEvent.COLLAPSE
 * @eventType ext.events.GlobalEvents_componentEvent.COLLAPSE
 */
[Event(name = 'onCollapse', type = 'ext.events.GlobalEvents_componentEvent')]
/**
 * @see ext.events.GlobalEvents_componentEvent.EXPAND
 * @eventType ext.events.GlobalEvents_componentEvent.EXPAND
 */
[Event(name = 'onExpand', type = 'ext.events.GlobalEvents_componentEvent')]
/**
 * @see ext.events.GlobalEvents_componentEvent.HIDE
 * @eventType ext.events.GlobalEvents_componentEvent.HIDE
 */
[Event(name = 'onHide', type = 'ext.events.GlobalEvents_componentEvent')]
/**
 * @see ext.events.GlobalEventsEvent.IDLE
 * @eventType ext.events.GlobalEventsEvent.IDLE
 */
[Event(name = 'onIdle', type = 'ext.events.GlobalEventsEvent')]
/**
 * @see ext.events.GlobalEvents_eEvent.MOUSE_DOWN
 * @eventType ext.events.GlobalEvents_eEvent.MOUSE_DOWN
 */
[Event(name = 'onMouseDown', type = 'ext.events.GlobalEvents_eEvent')]
/**
 * @see ext.events.GlobalEvents_eEvent.MOUSE_UP
 * @eventType ext.events.GlobalEvents_eEvent.MOUSE_UP
 */
[Event(name = 'onMouseUp', type = 'ext.events.GlobalEvents_eEvent')]
/**
 * @see ext.events.GlobalEvents_onlineEvent.ONLINE_CHANGE
 * @eventType ext.events.GlobalEvents_onlineEvent.ONLINE_CHANGE
 */
[Event(name = 'onOnlineChange', type = 'ext.events.GlobalEvents_onlineEvent')]
/**
 * @see ext.events.GlobalEvents_componentEvent.REMOVED
 * @eventType ext.events.GlobalEvents_componentEvent.REMOVED
 */
[Event(name = 'onRemoved', type = 'ext.events.GlobalEvents_componentEvent')]
/**
 * @see ext.events.GlobalEvents_width_heightEvent.RESIZE
 * @eventType ext.events.GlobalEvents_width_heightEvent.RESIZE
 */
[Event(name = 'onResize', type = 'ext.events.GlobalEvents_width_heightEvent')]
/**
 * @see ext.events.GlobalEvents_contextEvent.RESPONSIVE_UPDATE
 * @eventType ext.events.GlobalEvents_contextEvent.RESPONSIVE_UPDATE
 */
[Event(name = 'onResponsiveUpdate', type = 'ext.events.GlobalEvents_contextEvent')]
/**
 * @see ext.events.GlobalEventsEvent.RESUME_LAYOUTS
 * @eventType ext.events.GlobalEventsEvent.RESUME_LAYOUTS
 */
[Event(name = 'onResumeLayouts', type = 'ext.events.GlobalEventsEvent')]
/**
 * @see ext.events.GlobalEvents_routeEvent.ROUTE_REJECT
 * @eventType ext.events.GlobalEvents_routeEvent.ROUTE_REJECT
 */
[Event(name = 'onRouteReject', type = 'ext.events.GlobalEvents_routeEvent')]
/**
 * @see ext.events.GlobalEvents_componentEvent.SHOW
 * @eventType ext.events.GlobalEvents_componentEvent.SHOW
 */
[Event(name = 'onShow', type = 'ext.events.GlobalEvents_componentEvent')]
/**
 * An <code>→ext.mixin.Observable</code> through which Ext fires global events.
 * <p>Ext.on() and Ext.un() are shorthand for →<code>addListener()</code> and →<code>removeListener()</code>
 * on this Observable. For example, to listen for the idle event:</p>
 * <pre>
 * Ext.on('idle', function() {
 *     // do something
 * });
 * </pre>
 * <p>Type of singleton GlobalEvents.</p>
 * @see ext.mixin.Observable
 * @see SGlobalEvents#addListener()
 * @see SGlobalEvents#removeListener()
 * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.GlobalEvents.html Original Ext JS documentation of 'Ext.GlobalEvents'
 * @see ext.#GlobalEvents ext.GlobalEvents
 */
public class SGlobalEvents extends ext.mixin.Observable {
  /**
   * @inheritDoc
   */
  public function SGlobalEvents(config:ext.mixin.Observable = null) {
    super();
  }
}
}