package ext {
import ext.env.Browser;

[Native("Ext.browser")]
/**
 * Provides useful information about the current browser.
 * <p>Example:</p>
 * <pre>
 * if (Ext.browser.is.IE) {
 *     // IE specific code here
 * }
 *
 * if (Ext.browser.is.WebKit) {
 *     // WebKit specific code here
 * }
 *
 * console.log("Version " + Ext.browser.version);
 * </pre>
 * <p>For a full list of supported values, refer to →<code>matches()</code> property/method.</p>
 * @see Sbrowser#matches()
 * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.browser.html Original Ext JS documentation of 'Ext.browser'
 */
public const browser:ext.env.Browser;
}