package ext.chart.events {
import ext.chart.AbstractChart;
import js.Event;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.chart.events.AbstractChart_item_eventEvent")]
public class AbstractChart_item_eventEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fires when a click event occurs on a series item.
   * <i>Note</i>: This event requires the <i>chartitemevents</i> (→<code>ext.chart.plugin.ChartItemEventsPlugin</code>)
   * plugin be added to the chart.
   * @see ext.chart.plugin.ChartItemEventsPlugin
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.AbstractChart.html#event-itemclick Original Ext JS documentation of 'itemclick'
   * @see ext.chart.AbstractChart
   * @eventType onItemClick
   */
  public static const ITEM_CLICK:String = "onItemClick";

  /**
   * Fires when a double click event occurs on a series item.
   * <i>Note</i>: This event requires the <i>chartitemevents</i> (→<code>ext.chart.plugin.ChartItemEventsPlugin</code>)
   * plugin be added to the chart.
   * @see ext.chart.plugin.ChartItemEventsPlugin
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.AbstractChart.html#event-itemdblclick Original Ext JS documentation of 'itemdblclick'
   * @see ext.chart.AbstractChart
   * @eventType onItemDblclick
   */
  public static const ITEM_DBLCLICK:String = "onItemDblclick";

  /**
   * Fires when a mousedown event occurs on a series item.
   * <i>Note</i>: This event requires the <i>chartitemevents</i> (→<code>ext.chart.plugin.ChartItemEventsPlugin</code>)
   * plugin be added to the chart.
   * @see ext.chart.plugin.ChartItemEventsPlugin
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.AbstractChart.html#event-itemmousedown Original Ext JS documentation of 'itemmousedown'
   * @see ext.chart.AbstractChart
   * @eventType onItemMouseDown
   */
  public static const ITEM_MOUSE_DOWN:String = "onItemMouseDown";

  /**
   * Fires when the mouse is moved on a series item.
   * <i>Note</i>: This event requires the <i>chartitemevents</i> (→<code>ext.chart.plugin.ChartItemEventsPlugin</code>)
   * plugin be added to the chart.
   * @see ext.chart.plugin.ChartItemEventsPlugin
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.AbstractChart.html#event-itemmousemove Original Ext JS documentation of 'itemmousemove'
   * @see ext.chart.AbstractChart
   * @eventType onItemMouseMove
   */
  public static const ITEM_MOUSE_MOVE:String = "onItemMouseMove";

  /**
   * Fires when the mouse exits a series item.
   * <i>Note</i>: This event requires the <i>chartitemevents</i> (→<code>ext.chart.plugin.ChartItemEventsPlugin</code>)
   * plugin be added to the chart.
   * @see ext.chart.plugin.ChartItemEventsPlugin
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.AbstractChart.html#event-itemmouseout Original Ext JS documentation of 'itemmouseout'
   * @see ext.chart.AbstractChart
   * @eventType onItemMouseOut
   */
  public static const ITEM_MOUSE_OUT:String = "onItemMouseOut";

  /**
   * Fires when the mouse enters a series item.
   * <i>Note</i>: This event requires the <i>chartitemevents</i> (→<code>ext.chart.plugin.ChartItemEventsPlugin</code>)
   * plugin be added to the chart.
   * @see ext.chart.plugin.ChartItemEventsPlugin
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.AbstractChart.html#event-itemmouseover Original Ext JS documentation of 'itemmouseover'
   * @see ext.chart.AbstractChart
   * @eventType onItemMouseOver
   */
  public static const ITEM_MOUSE_OVER:String = "onItemMouseOver";

  /**
   * Fires when a mouseup event occurs on a series item.
   * <i>Note</i>: This event requires the <i>chartitemevents</i> (→<code>ext.chart.plugin.ChartItemEventsPlugin</code>)
   * plugin be added to the chart.
   * @see ext.chart.plugin.ChartItemEventsPlugin
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.AbstractChart.html#event-itemmouseup Original Ext JS documentation of 'itemmouseup'
   * @see ext.chart.AbstractChart
   * @eventType onItemMouseUp
   */
  public static const ITEM_MOUSE_UP:String = "onItemMouseUp";

  /**
   * Fires when a tap event occurs on a series item.
   * <i>Note</i>: This event requires the <i>chartitemevents</i> (→<code>ext.chart.plugin.ChartItemEventsPlugin</code>)
   * plugin be added to the chart.
   * @see ext.chart.plugin.ChartItemEventsPlugin
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.AbstractChart.html#event-itemtap Original Ext JS documentation of 'itemtap'
   * @see ext.chart.AbstractChart
   * @eventType onItemTap
   */
  public static const ITEM_TAP:String = "onItemTap";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function AbstractChart_item_eventEvent(type:String, arguments:Array) {
    super(null, null);
  }

  public native function get chart():ext.chart.AbstractChart;

  public native function get event():js.Event;

  public native function get item():Object;
}
}