package ext.chart.series.events {
import ext.chart.AbstractChart;
import ext.chart.series.Series;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.chart.series.events.Series_chart_seriesEvent")]
public class Series_chart_seriesEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fires when the →<code>ext.chart.AbstractChart</code> has been attached to this series.
   * @see ext.chart.AbstractChart
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.series.Series.html#event-chartattached Original Ext JS documentation of 'chartattached'
   * @see ext.chart.series.Series
   * @eventType onChartAttached
   */
  public static const CHART_ATTACHED:String = "onChartAttached";

  /**
   * Fires when the →<code>ext.chart.AbstractChart</code> has been detached from this series.
   * @see ext.chart.AbstractChart
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.series.Series.html#event-chartdetached Original Ext JS documentation of 'chartdetached'
   * @see ext.chart.series.Series
   * @eventType onChartDetached
   */
  public static const CHART_DETACHED:String = "onChartDetached";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function Series_chart_seriesEvent(type:String, arguments:Array) {
    super(null, null);
  }

  public native function get chart():ext.chart.AbstractChart;

  public native function get series():ext.chart.series.Series;
}
}