package ext.chart.series.sprite {

[Native("Ext.chart.series.sprite.Aggregative", require)]
/**
 * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.series.sprite.Aggregative.html Original Ext JS documentation of 'Ext.chart.series.sprite.Aggregative'
 */
public class AggregativeSeriesSprite extends ext.chart.series.sprite.CartesianSeriesSprite {
  /**
   * @inheritDoc
   */
  public function AggregativeSeriesSprite(config:ext.chart.series.sprite.AggregativeSeriesSprite = null) {
    super();
  }

  [ArrayElementType("Number")]
  [ExtConfig]
  /**
   * Data items representing the closing values
   * of the aggregated data.
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.series.sprite.Aggregative.html#cfg-dataClose Original Ext JS documentation of 'dataClose'
   */
  public native function get dataClose():Array;

  [ExtConfig]
  /**
   * @private
   */
  public native function set dataClose(value:Array):void;

  [ArrayElementType("Number")]
  [ExtConfig]
  /**
   * Data items representing the high values
   * of the aggregated data.
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.series.sprite.Aggregative.html#cfg-dataHigh Original Ext JS documentation of 'dataHigh'
   */
  public native function get dataHigh():Array;

  [ExtConfig]
  /**
   * @private
   */
  public native function set dataHigh(value:Array):void;

  [ArrayElementType("Number")]
  [ExtConfig]
  /**
   * Data items representing the low values
   * of the aggregated data.
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.series.sprite.Aggregative.html#cfg-dataLow Original Ext JS documentation of 'dataLow'
   */
  public native function get dataLow():Array;

  [ExtConfig]
  /**
   * @private
   */
  public native function set dataLow(value:Array):void;

  [ArrayElementType("Number")]
  [ExtConfig]
  /**
   * Data items representing the opening values
   * of the aggregated data.
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.series.sprite.Aggregative.html#cfg-dataOpen Original Ext JS documentation of 'dataOpen'
   */
  public native function get dataOpen():Array;

  [ExtConfig]
  /**
   * @private
   */
  public native function set dataOpen(value:Array):void;
}
}