package ext.chart.series.sprite {

[Native("Ext.chart.series.sprite.Area", require)]
/**
 * Area series sprite.
 * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.series.sprite.Area.html Original Ext JS documentation of 'Ext.chart.series.sprite.Area'
 */
public class AreaSeriesSprite extends ext.chart.series.sprite.StackedCartesianSeriesSprite {
  /**
   * @inheritDoc
   */
  public function AreaSeriesSprite(config:ext.chart.series.sprite.AreaSeriesSprite = null) {
    super();
  }

  [ExtConfig]
  /**
   * 'true' if the area is represented with steps
   * instead of lines.
   * @default false
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.series.sprite.Area.html#cfg-step Original Ext JS documentation of 'step'
   */
  public native function get step():Boolean;

  [ExtConfig]
  /**
   * @private
   */
  public native function set step(value:Boolean):void;
}
}