package ext.chart.theme.series {

[Native("Ext.chart.theme.series.CandleStick", require)]
/**
 * Describes style for a candlestick series.
 * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.theme.series.CandleStick.html Original Ext JS documentation of 'Ext.chart.theme.series.CandleStick'
 */
public class CandleStickSeriesTheme extends ext.chart.theme.series.SeriesTheme {
  [ExtConfig]
  /**
   * The bar width of the candles.
   * @default 15
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.theme.series.CandleStick.html#cfg-barWidth Original Ext JS documentation of 'barWidth'
   */
  public native function get barWidth():Number;

  [ExtConfig]
  /**
   * @private
   */
  public native function set barWidth(value:Number):void;

  [ExtConfig]
  /**
   * Determines whether candlestick
   * or ohlc is used.
   * @default 'candlestick'
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.theme.series.CandleStick.html#cfg-ohlcType Original Ext JS documentation of 'ohlcType'
   */
  public native function get ohlcType():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set ohlcType(value:String):void;

  [ExtConfig]
  /**
   * The amount of padding between candles.
   * @default 3
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.chart.theme.series.CandleStick.html#cfg-padding Original Ext JS documentation of 'padding'
   */
  public native function get padding():Number;

  [ExtConfig]
  /**
   * @private
   */
  public native function set padding(value:Number):void;
}
}