package ext.data.events {
import ext.data.NodeInterface;
import ext.data.TreeStore;
import ext.data.operation.Operation;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.data.events.TreeStore_records_successful_operation_nodeEvent")]
public class TreeStore_records_successful_operation_nodeEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fires whenever the store reads data from a remote data source.
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.data.TreeStore.html#event-load Original Ext JS documentation of 'load'
   * @see ext.data.TreeStore
   * @eventType onLoad
   */
  public static const LOAD:String = "onLoad";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function TreeStore_records_successful_operation_nodeEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The node that was loaded.
   */
  public native function get node():ext.data.NodeInterface;

  /**
   * The operation that triggered this load.
   */
  public native function get operation():ext.data.operation.Operation;

  [ArrayElementType("ext.data.TreeModel")]
  /**
   * An array of records.
   */
  public native function get records():Array;

  public native function get source():ext.data.TreeStore;

  /**
   * True if the operation was successful.
   */
  public native function get successful():Boolean;
}
}