package ext.data.operation {

[Native("Ext.data.operation.Update", require)]
/**
 * Encapsulates a update operation as performed by a <i>proxy</i> (→<code>ext.data.proxy.DataProxy</code>).
 * <p>This class is instantiated by <i>stores</i> (→<code>ext.data.Store</code>) and <i>records</i> (→<code>ext.data.Model</code>)
 * and should not need to be instantiated in user code.</p>
 * @see ext.data.proxy.DataProxy
 * @see ext.data.Store
 * @see ext.data.Model
 * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.data.operation.Update.html Original Ext JS documentation of 'Ext.data.operation.Update'
 */
public class UpdateOperation extends ext.data.operation.Operation {
  /**
   * @param config @inheritDoc
   */
  public function UpdateOperation(config:ext.data.operation.UpdateOperation = null) {
    super();
  }
}
}