package ext.data.schema {

[Native("Ext.data.schema.HasOne", require)]
/**
 * <b>This is not a real JavaScript class and cannot be created. This is for documentation
 * purposes only.</b>
 * <p>This class provides for creating a keyless <code>→ext.data.schema.OneToOne</code> association. This
 * declaration should be on "owner" entity. See <code>→ext.data.schema.OneToOne</code> and
 * <code>→ext.data.schema.Association</code> for more information.</p>
 * @see ext.data.schema.OneToOne
 * @see ext.data.schema.Association
 * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.data.schema.HasOne.html Original Ext JS documentation of 'Ext.data.schema.HasOne'
 */
public class HasOne extends Object {
  [ExtConfig]
  /**
   * An alias for →<code>ext.data.schema.Reference.role</code>.
   * @see ext.data.schema.Reference#role
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.data.schema.HasOne.html#cfg-associatedName Original Ext JS documentation of 'associatedName'
   */
  public native function get associatedName():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set associatedName(value:String):void;

  [Deprecated(replacement = "reference", since = "6.2.0")]
  [ExtConfig]
  /**
   * The key field to use in this association
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.data.schema.HasOne.html#cfg-foreignKey Original Ext JS documentation of 'foreignKey'
   */
  public native function get foreignKey():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set foreignKey(value:String):void;

  [ExtConfig]
  /**
   * An alias for →<code>ext.data.schema.Reference.type</code>.
   * @see ext.data.schema.Reference#type
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.data.schema.HasOne.html#cfg-model Original Ext JS documentation of 'model'
   */
  public native function get model():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set model(value:String):void;

  [ExtConfig]
  /**
   * An alias for →<code>ext.data.schema.Reference.role</code>.
   * @see ext.data.schema.Reference#role
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.data.schema.HasOne.html#cfg-name Original Ext JS documentation of 'name'
   */
  public native function get name():String;

  [ExtConfig]
  /**
   * @private
   */
  public native function set name(value:String):void;
}
}