package ext {

[Native("Ext.feature", require)]
/**
 * A simple class to verify if a browser feature exists or not on the current device.
 * <pre>
 * if (Ext.feature.has.Canvas) {
 *     // do some cool things with canvas here
 * }
 * </pre>
 * <p>See the →<code>has()</code> property/method for details of the features that can be detected.</p>
 * @see Sfeature#has()
 * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.feature.html Original Ext JS documentation of 'Ext.feature'
 */
public const feature:ext.Sfeature;
}