package ext.form.events {
import ext.form.FieldAncestor;
import ext.form.Labelable;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.form.events.FieldContainer_field_errorEvent")]
public class FieldContainer_field_errorEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fires when the active error message is changed for any one of the →<code>ext.form.Labelable</code>
   * instances within this container.
   * @see ext.form.Labelable
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.form.FieldAncestor.html#event-fielderrorchange Original Ext JS documentation of 'fielderrorchange'
   * @see ext.form.FieldContainer
   * @eventType onFieldErrorChange
   */
  public static const FIELD_ERROR_CHANGE:String = "onFieldErrorChange";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function FieldContainer_field_errorEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The active error message
   */
  public native function get error():String;

  /**
   * The Labelable instance whose active error was changed
   */
  public native function get field():ext.form.Labelable;

  public native function get source():ext.form.FieldAncestor;
}
}