package ext.form.field.events {
import ext.data.Model;
import ext.form.field.ComboBox;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.form.field.events.ComboBox_record_indexEvent")]
public class ComboBox_record_indexEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fires before the deselected item is removed from the collection
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.form.field.ComboBox.html#event-beforedeselect Original Ext JS documentation of 'beforedeselect'
   * @see ext.form.field.ComboBox
   * @eventType onBeforeDeselect
   */
  public static const BEFORE_DESELECT:String = "onBeforeDeselect";

  /**
   * Fires before the selected item is added to the collection
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.form.field.ComboBox.html#event-beforeselect Original Ext JS documentation of 'beforeselect'
   * @see ext.form.field.ComboBox
   * @eventType onBeforeSelect
   */
  public static const BEFORE_SELECT:String = "onBeforeSelect";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function ComboBox_record_indexEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * This combo box
   */
  public native function get combo():ext.form.field.ComboBox;

  /**
   * The index of the deselected record
   */
  public native function get index():Number;

  /**
   * The deselected record
   */
  public native function get record():ext.data.Model;
}
}