package ext.form.field.events {
import ext.form.field.Field;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.form.field.events.Field_isDirtyEvent")]
public class Field_isDirtyEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fires when a change in the field's →<code>isDirty()</code> state is detected.
   * @see ext.form.field.Field#isDirty()
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.form.field.Field.html#event-dirtychange Original Ext JS documentation of 'dirtychange'
   * @see ext.form.field.Field
   * @eventType onDirtyChange
   */
  public static const DIRTY_CHANGE:String = "onDirtyChange";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function Field_isDirtyEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * Whether or not the field is now dirty
   */
  public native function get isDirty():Boolean;

  public native function get source():ext.form.field.Field;
}
}