package ext.form.field.events {
import ext.form.field.Field;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.form.field.events.Field_isValidEvent")]
public class Field_isValidEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fires when a change in the field's validity is detected.
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.form.field.Field.html#event-validitychange Original Ext JS documentation of 'validitychange'
   * @see ext.form.field.Field
   * @eventType onValidityChange
   */
  public static const VALIDITY_CHANGE:String = "onValidityChange";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function Field_isValidEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * Whether or not the field is now valid
   */
  public native function get isValid():Boolean;

  public native function get source():ext.form.field.Field;
}
}