package ext.form.field.events {
import ext.form.field.Field;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.form.field.events.Field_newValue_oldValueEvent")]
public class Field_newValue_oldValueEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fires when the value of a field is changed. The value of a field is
   * checked for changes when the field's →<code>setValue()</code> method
   * is called and when any of the events listed in
   * →<code>ext.form.field.BaseField.checkChangeEvents</code> are fired.
   * @see ext.form.field.Field#setValue()
   * @see ext.form.field.BaseField#checkChangeEvents
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.form.field.Field.html#event-change Original Ext JS documentation of 'change'
   * @see ext.form.field.Field
   * @eventType onChange
   */
  public static const CHANGE:String = "onChange";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function Field_newValue_oldValueEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The new value
   */
  public native function get newValue():Object;

  /**
   * The original value
   */
  public native function get oldValue():Object;

  public native function get source():ext.form.field.Field;
}
}