package ext.grid.header.events {
import ext.event.Event;
import ext.grid.column.Column;
import ext.grid.header.HeaderContainer;
import js.HTMLElement;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.grid.header.events.HeaderContainer_column_e_tEvent")]
public class HeaderContainer_column_e_tEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.grid.header.Container.html#event-headerclick Original Ext JS documentation of 'headerclick'
   * @see ext.grid.header.HeaderContainer
   * @eventType onHeaderClick
   */
  public static const HEADER_CLICK:String = "onHeaderClick";

  /**
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.grid.header.Container.html#event-headercontextmenu Original Ext JS documentation of 'headercontextmenu'
   * @see ext.grid.header.HeaderContainer
   * @eventType onHeaderContextMenu
   */
  public static const HEADER_CONTEXT_MENU:String = "onHeaderContextMenu";

  /**
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.grid.header.Container.html#event-headertriggerclick Original Ext JS documentation of 'headertriggerclick'
   * @see ext.grid.header.HeaderContainer
   * @eventType onHeaderTriggerClick
   */
  public static const HEADER_TRIGGER_CLICK:String = "onHeaderTriggerClick";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function HeaderContainer_column_e_tEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The Column header Component which provides
   * the column definition
   */
  public native function get column():ext.grid.column.Column;

  /**
   * The grid's header Container which encapsulates
   * all column headers.
   */
  public native function get ct():ext.grid.header.HeaderContainer;

  public native function get e():ext.event.Event;

  public native function get t():js.HTMLElement;
}
}