package ext.grid.locking.events {
import ext.data.Store;
import ext.data.operation.Operation;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.grid.locking.events.Lockable_store_operationEvent")]
public class Lockable_store_operationEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fires before a request is made for a new data object. If the beforeload handler returns
   * <code>false</code> the load action will be canceled.
   * <p><b>Note:</b> If you are using a buffered store, you should use
   * →<code>ext.data.Store.event:onBeforePrefetch</code>.</p>
   * @see ext.data.Store#event:onBeforePrefetch
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.grid.locking.Lockable.html#event-beforeload Original Ext JS documentation of 'beforeload'
   * @see ext.grid.locking.Lockable
   * @eventType onBeforeLoad
   */
  public static const BEFORE_LOAD:String = "onBeforeLoad";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function Lockable_store_operationEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The Ext.data.operation.Operation object
   * that will be passed to the Proxy to load the Store
   */
  public native function get operation():ext.data.operation.Operation;

  /**
   * This Store
   */
  public native function get store():ext.data.Store;
}
}