package ext.mixin {

[Rename("Ext.mixin.AdvancedFocusableContainerMixin")]
public class AdvancedFocusableContainerMixin extends ext.mixin.FocusableContainer implements ext.mixin.IAdvancedFocusableContainerMixin {
  /**
   * Tab navigation disabled.
   *
   * @see #tabNavigationMode
   */
  public static const TAB_NAVIGATION_MODE_DISABLE:int = -1;

  /**
   * Tab navigation enabled (possibly in addition to arrow key navigation).
   *
   * @see #tabNavigationMode
   */
  public static const TAB_NAVIGATION_MODE_ENABLE:int = 0;

  /**
   * Only tab navigation allowed, arrow key navigation disabled.
   *
   * @see #tabNavigationMode
   */
  public static const TAB_NAVIGATION_MODE_ONLY:int = 1;

  /**
   * @inheritDoc
   */
  [ExtConfig]
  public native function get excludeInputFields():Boolean;

  /**
   * @private
   */
  [ExtConfig]
  public native function set excludeInputFields(nested:Boolean):void;

  /**
   * @inheritDoc
   */
  [ExtConfig]
  public native function get getFocusablesFn():Function;

  /**
   * @private
   */
  [ExtConfig]
  public native function set getFocusablesFn(fn:Function):void;

  /**
   * @inheritDoc
   */
  [ExtConfig]
  public native function get ignoreInputFields():Boolean;

  /**
   * @private
   */
  [ExtConfig]
  public native function set ignoreInputFields(nested:Boolean):void;

  /**
   * @inheritDoc
   */
  [ExtConfig]
  public native function get nestedFocusableItems():Boolean;

  /**
   * @private
   */
  [ExtConfig]
  public native function set nestedFocusableItems(nested:Boolean):void;

  /**
   * @inheritDoc
   */
  [ExtConfig]
  public native function get tabNavigationMode():int;

  /**
   * @private
   */
  [ExtConfig]
  public native function set tabNavigationMode(mode:int):void;
}
}