package ext.mixin {

[Mixin("ext.mixin.Identifiable")]
/**
 * <b>NOTE: This is a private utility class for internal use by the framework. Don't rely on its existence.</b>
 * <p>An Identifiable mixin.</p>
 * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.mixin.Identifiable.html Original Ext JS documentation of 'Ext.mixin.Identifiable'
 * @see ext.mixin.Identifiable
 */
public interface IIdentifiable {
  /**
   * Retrieves the <code>id</code>. This method Will auto-generate an id if one has not already
   * been configured.
   * @return id
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.mixin.Identifiable.html#method-getId Original Ext JS documentation of 'getId'
   */
  function getId():String;
}
}