package ext.panel.events {
import ext.event.Event;
import ext.panel.PanelHeader;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.panel.events.PanelHeader_eEvent")]
public class PanelHeader_eEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fires when the header is clicked. This event will not be fired
   * if the click was on a →<code>ext.panel.Tool</code>
   * @see ext.panel.Tool
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.panel.Header.html#event-click Original Ext JS documentation of 'click'
   * @see ext.panel.PanelHeader
   * @eventType onClick
   */
  public static const CLICK:String = "onClick";

  /**
   * Fires when the header is double clicked. This event will not
   * be fired if the click was on a →<code>ext.panel.Tool</code>
   * @see ext.panel.Tool
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.panel.Header.html#event-dblclick Original Ext JS documentation of 'dblclick'
   * @see ext.panel.PanelHeader
   * @eventType onDblclick
   */
  public static const DBLCLICK:String = "onDblclick";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function PanelHeader_eEvent(type:String, arguments:Array) {
    super(null, null);
  }

  public native function get e():ext.event.Event;

  public native function get source():ext.panel.PanelHeader;
}
}