package ext.toolbar {

[Native("Ext.toolbar.Separator", require)]
/**
 * A simple class that adds a vertical separator bar between toolbar items
 * (css class: 'x-toolbar-separator').
 * <p><b>Example:</b></p>
 * <pre>
 * Ext.create('Ext.panel.Panel', {
 *     title: 'Toolbar Separator Example',
 *     width: 300,
 *     height: 200,
 *     tbar : [
 *         'Item 1',
 *         { xtype: 'tbseparator' },
 *         'Item 2'
 *     ],
 *     renderTo: Ext.getBody()
 * });
 * </pre>
 * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.toolbar.Separator.html Original Ext JS documentation of 'Ext.toolbar.Separator'
 */
public class Separator extends ext.toolbar.Item {
  /**
   * @param config @inheritDoc
   */
  public function Separator(config:ext.toolbar.Separator = null) {
    super();
  }
}
}