package ext.view.events {
import ext.data.Model;
import ext.selection.DataViewSelectionModel;
import net.jangaroo.ext.FlExtEvent;

[Rename("Ext.view.events.DataView_record_indexEvent")]
public class DataView_record_indexEvent extends net.jangaroo.ext.FlExtEvent {
  /**
   * Fired before a record is deselected. If any listener returns false, the
   * deselection is cancelled.
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.view.View.html#event-beforedeselect Original Ext JS documentation of 'beforedeselect'
   * @see ext.view.DataView
   * @eventType onBeforeDeselect
   */
  public static const BEFORE_DESELECT:String = "onBeforeDeselect";

  /**
   * Fired before a record is selected. If any listener returns false, the
   * selection is cancelled.
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.view.View.html#event-beforeselect Original Ext JS documentation of 'beforeselect'
   * @see ext.view.DataView
   * @eventType onBeforeSelect
   */
  public static const BEFORE_SELECT:String = "onBeforeSelect";

  /**
   * Fired after a record is selected
   * @see https://docs.sencha.com/extjs/7.2.0/classic/Ext.view.View.html#event-select Original Ext JS documentation of 'select'
   * @see ext.view.DataView
   * @eventType onSelect
   */
  public static const SELECT:String = "onSelect";

  public static const __PARAMETER_SEQUENCE__:Array;

  public function DataView_record_indexEvent(type:String, arguments:Array) {
    super(null, null);
  }

  /**
   * The index within the store of the deselected record.
   */
  public native function get index():Number;

  /**
   * The deselected record.
   */
  public native function get record():ext.data.Model;

  public native function get source():ext.selection.DataViewSelectionModel;
}
}