/*package ext.system {
import ext.ArrayUtil;
import ext.Deferred;
import ext.Ext;
import ext.IPromise;
import ext.Loader;
import ext.Promise;

import joo.localeSupport;

import js.XMLHttpRequest;

[Rename("Ext.system.PackageEntry")]*/
Ext.define("Ext.system.PackageEntry", function(PackageEntry) {/*internal class PackageEntry {

  private static const*/var PACKAGE_JSON$static/*:String*/ = "/package.json";/*
  private static const*/var PACKAGE_PREFIX$static/*:String*/ = "package.";/*

  private var _name:String;
  private var _manifestPromise:IPromise;
  private var _transitiveScriptsPromise:IPromise;

  public*/ function PackageEntry$(name/*:String*/) {
    this._name$MttU = name;
  }/*

  internal*/ function  get$name()/*:String*/ {
    return this._name$MttU;
  }/*

  internal*/ function  get$manifest()/*:Object*/ {
    return Ext.manifest.packages[this.name];
  }/*

  internal*/ function loadManifest()/*:IPromise*/ {
    if (!this._manifestPromise$MttU) {
      if (this.manifest) {
        this.manifest.name = this.name; // may be missing in pre-loaded packages!
        this._manifestPromise$MttU = Ext.Deferred.resolved(this.manifest);
      } else {
        this._manifestPromise$MttU = this.doLoadPackageJson$MttU("packages/" + this._name$MttU);
      }
    }
    return this._manifestPromise$MttU;
  }/*

  private*/ function doLoadPackageJson(packageDir/*:String*/)/*:IPromise*/ {var _this=this;
    return Ext.system.PackageLoader.loadJson(packageDir + PACKAGE_JSON$static)
            .then(function (json/*:Object*/)/*:Object*/ {
                      var manifest/*:Object*/ = Ext.manifest.packages[_this.name] = json;
                      manifest.dir = packageDir;
                      manifest.locale = joo.localeSupport.getLocale();
                      manifest.loaded = false;
                      return manifest;
                    },
                    function (response/*:XMLHttpRequest*/)/*:void*/ {
                      throw new AS3.Error("Failed to load package " + _this.name + ".");
                    }
            );
  }/*

  private static*/ function selectName$static(dependency/*:Object*/)/*:String*/ {
    return dependency.name || (typeof dependency === "string" ? String(dependency) : null);
  }/*

  internal*/ function  get$dependencies()/*:Array*/ {
    return (this.name !== "core" && this.manifest.requires || []).map(selectName$static).filter(function(dependency/*:String*/)/*:Boolean*/ {
      return ! !dependency;
    });
  }/*

  internal*/ function loadScripts()/*:IPromise*/ {var _this=this;
    if (!this._transitiveScriptsPromise$MttU) {
      this._transitiveScriptsPromise$MttU = this.loadManifest().then(function (manifest/*:Object*/)/*:Object*/ {
        if (manifest && manifest.loaded === false) {
          return Ext.Promise.all(_this.dependencies.map(Ext.system.PackageLoader.loadScripts))
                  .then(AS3.bind(_this,"loadJsAndCss$MttU"))
                  .then(AS3.bind(_this,"loadClasspath$MttU"))
                  .then(AS3.bind(_this,"loadOverrides$MttU"))
                  .then(AS3.bind(_this,"allScriptsLoaded$MttU"),AS3.bind( _this,"allScriptsLoaded$MttU")); // ignore errors when loading overrides!
        }
        return null;
      });
    }
    return this._transitiveScriptsPromise$MttU;
  }/*

  private*/ function allScriptsLoaded()/*:void*/ {
    this.manifest.loaded = true;
  }/*

  [ArrayElementType("String")]
  private static*/ function splitAtComma$static(str/*:String*/)/*:Array*/ {
    return str.split(",");
  }/*

  [ArrayElementType("String")]
  private*/ function convertToUrlArray(path/*:Array*/)/*:Array*/ {
    return Ext.Array.flatten((path || []).map(Ext.system.PlaceholderReplacer.substitutePlaceholders(this.manifest, PACKAGE_PREFIX$static)).map(splitAtComma$static));
  }/*

  private*/ function loadJsAndCss()/*:IPromise*/ {
    return this.loadManifest().then(function(manifest/*:Object*/)/*:IPromise*/ {

      // JavaScript descriptors where bundled scripts are loaded after non-bundled ones.
      var jsDescriptors/*:Array*/ = ((manifest.development || {})['js'] || []).concat(manifest.js || []);
      // Likewise for CSS.
      var cssDescriptors/*:Array*/ = ((manifest.development || {})['css'] || []).concat(manifest.css || []);

      var descriptors/*:Array*/ = jsDescriptors.concat(cssDescriptors);

      var urls/*:Array*/ = descriptors
              .map(function (jsDescriptor/*:Object*/)/*:String*/ {
                return manifest.dir + "/" + jsDescriptor.path;
              });
      return loadScriptsSequentially$static(urls, false);
    });
  }/*

  private*/ function loadClasspath()/*:IPromise*/ {
    var urls/*:Array*/ = this.convertToUrlArray$MttU(this.manifest.classpath);
    return Ext.Promise.all(urls.map(AS3.bind(this,"loadPackageDefines$MttU"))).then(function()/*:IPromise*/ {
      return loadScriptsSequentially$static(urls, false);
    });
  }/*

  private*/ function loadPackageDefines(jsUrl/*:String*/)/*:IPromise*/ {
    var jsonUrl/*:String*/ = jsUrl.replace(/\.js$/, ".json");
    return Ext.system.PackageLoader.loadJson(jsonUrl).then(function (definesList/*:Array*/)/*:void*/ {
              definesList.forEach(function (define/*:String*/)/*:void*/ {
                Ext.Loader.setPath(define, jsUrl);
              });
            }, Ext.emptyFn // ignore missing defines lists (module without TOC)
    );
  }/*

  private static const*/var OVERRIDES_FILTER_PATTERN$static/*:RegExp*/;/* =*/function OVERRIDES_FILTER_PATTERN$static_(){OVERRIDES_FILTER_PATTERN$static=( new RegExp("overrides(-" + joo.localeSupport.getDefaultLocale() + ")?\\.js$"));}/*

  //additional loading of overrides
  private*/ function loadOverrides()/*:IPromise*/ {
    var urls/*:Array*/ = this.convertToUrlArray$MttU(this.manifest.overrides);
    urls = urls.filter(function(url/*:String*/)/*:Boolean*/ {
      return !url.match(OVERRIDES_FILTER_PATTERN$static);
    });
    return loadScriptsSequentially$static(urls, true);
  }/*

  private static*/ function loadScriptsSequentially$static(urls/*:Array*/, ignoreErrors/*:Boolean*/)/*:IPromise*/ {
    var result/*:IPromise*/ = Ext.Promise.resolve(true);
    urls.forEach(function(url/*:String*/)/*:void*/ {
      function next()/*:IPromise*/ {
        return loadScript$static(url);
      }
      result = result.then(next, ignoreErrors ? next : null);
    });
    return result;
  }/*

  private static*/ function loadScript$static(url/*:String*/)/*:IPromise*/ {
    var result/*:Deferred*/ = new Ext.Deferred();
    Ext.Loader.loadScript({
      url: url,
      onLoad:AS3.bind( result,"resolve"),
      onError:AS3.bind( result,"reject")
    });
    return result;
  }/*

}
}

============================================== Jangaroo part ==============================================*/
    return {
      alternateClassName: "ext.system.PackageEntry",
      _name$MttU: null,
      _manifestPromise$MttU: null,
      _transitiveScriptsPromise$MttU: null,
      constructor: PackageEntry$,
      loadManifest: loadManifest,
      doLoadPackageJson$MttU: doLoadPackageJson,
      loadScripts: loadScripts,
      allScriptsLoaded$MttU: allScriptsLoaded,
      convertToUrlArray$MttU: convertToUrlArray,
      loadJsAndCss$MttU: loadJsAndCss,
      loadClasspath$MttU: loadClasspath,
      loadPackageDefines$MttU: loadPackageDefines,
      loadOverrides$MttU: loadOverrides,
      statics: {__initStatics__: function() {
          OVERRIDES_FILTER_PATTERN$static_();
        }},
      __accessors__: {
        name: {get: get$name},
        manifest: {get: get$manifest},
        dependencies: {get: get$dependencies}
      },
      requires: ["AS3.Error"],
      uses: [
        "Ext",
        "Ext.Array",
        "Ext.Deferred",
        "Ext.Loader",
        "Ext.Promise",
        "Ext.system.PackageLoader",
        "Ext.system.PlaceholderReplacer"
      ]
    };
});
