/*package ext.system {
import ext.Ajax;
import ext.ArrayUtil;
import ext.Ext;
import ext.IPromise;
import ext.JSON;
import ext.Promise;

import js.XMLHttpRequest;

[Rename("Ext.system.PackageLoader")]*/
Ext.define("Ext.system.PackageLoader", function(PackageLoader) {/*public class PackageLoader {

  private static*/ var _packageListPromise$static/*:IPromise*/=null;/*

  private static const*/var PACKAGE_ENTRIES_BY_NAME$static/*:Object*/;/* =*/function PACKAGE_ENTRIES_BY_NAME$static_(){PACKAGE_ENTRIES_BY_NAME$static=( {});}/*

  internal static*/ function getPackageEntry$static(name/*:String*/)/*:PackageEntry*/ {
    var packageEntry/*:PackageEntry*/ = PACKAGE_ENTRIES_BY_NAME$static[name];
    if (!packageEntry) {
      packageEntry = PACKAGE_ENTRIES_BY_NAME$static[name] = new Ext.system.PackageEntry(name);
    }
    return packageEntry;
  }/*

  private static const*/var DYNAMIC_PACKAGES_JSON$static/*:String*/ = "dynamic-packages.json";/*
  private static const*/var ADDITIONAL_PACKAGES_URL_PATH$static/*:String*/ = "additional-packages/";/*

  public static*/ function loadPackageList$static(localPackagesOnly/*:Boolean = false*/)/*:IPromise*/ {if(arguments.length<=0)localPackagesOnly=false;
    if (!_packageListPromise$static) {
      _packageListPromise$static = (localPackagesOnly
              ? PackageLoader.loadJson(DYNAMIC_PACKAGES_JSON$static + "?local-only", [])
              : Ext.Promise.all([
                PackageLoader.loadJson(DYNAMIC_PACKAGES_JSON$static, []),
                PackageLoader.loadJson(ADDITIONAL_PACKAGES_URL_PATH$static, [])
                    .then(directoryIndexToStringArray$static)
                    .then(loadFromDirectories$static)
                    .then(uniteAll$static)
              ]).then(uniteAll$static)
      ).then(concatStaticAndDynamicPackages$static);
    }
    return _packageListPromise$static;
  }/*

  private static*/ function loadFromDirectories$static(directories/*: Array*//*<String>*/)/*: IPromise*//*<String[]>*/ {
    return Ext.Promise.all(directories.map(function(directory/*: String*/)/*: IPromise*/ {
      return PackageLoader.loadJson(ADDITIONAL_PACKAGES_URL_PATH$static + directory +"/", [])
          .then(directoryIndexToStringArray$static);
    }));
  }/*

  [ArrayElementType("String")]
  private static*/ function concatStaticAndDynamicPackages$static(dynamicPackages/*:Array*/)/*:Array*/ {
    // start with statically linked packages:
    var packages/*:Array*/ = Object.keys(Ext.manifest.packages);
    if (Ext.isArray(dynamicPackages)) {
      // add dynamic packages, avoiding duplicates:
      return Ext.Array.union(packages, dynamicPackages);
    }
    return packages;
  }/*

  [ArrayElementType("String")]
  private static*/ function directoryIndexToStringArray$static(directoryContents/*: Array*/)/*: Array*/ {
    return !Ext.isArray(directoryContents) ? []
        : directoryContents.filter(function(rec/*: Object*/)/*: Boolean*/ {
          return ! !rec && ! !rec.name && rec.type === "directory";
        }).map(function(rec/*: Object*/)/*: String*/ {
          return rec.name;
        });
  }/*

  private static*/ function uniteAll$static(packagesArrays/*: Array*/)/*: Array*/ {
    return Ext.Array.union.apply(Ext.Array, packagesArrays);
  }/*

  internal static*/ function loadJson$static(url/*:String*/, valueOnError/*: Object = null*/)/*:IPromise*/ {if(arguments.length<=1)valueOnError=null;
    return Ext.Ajax.request({
      url: url,
      method: 'GET',
      headers: {
        'Accept': "application/json, application/octet-stream"
      }
    }).then(toJson$static, valueOnError ? function()/*: Object*/ {
      return valueOnError;
    } : null);
  }/*

  private static*/ function toJson$static(response/*:XMLHttpRequest*/)/*:Object*/ {
    var jsonString/*:String*/ = response.responseText;
    // remove illegal comments:
    jsonString = jsonString.replace(/\/\*(.|\s)*?\*\//g, "");
    return Ext.JSON.decode(jsonString);
  }/*

  public static*/ function loadManifest$static(packageName/*:String*/)/*:IPromise*/ {
    return PackageLoader.getPackageEntry(packageName).loadManifest();
  }/*

  public static*/ function getLoadedManifest$static(name/*:String*/)/*:Object*/ {
    return Ext.manifest.packages[name];
  }/*

  public static*/ function loadManifests$static(packageNames/*:Array*/)/*:IPromise*/ {
    return Ext.Promise.all(packageNames.map(PackageLoader.loadManifest));
  }/*

  public static*/ function loadTransitiveManifests$static(packageNames/*:Array*/)/*:IPromise*/ {
    return PackageLoader.loadManifests(packageNames).then(function(manifests/*:Array*/)/*:**/ {
      var morePackageNames/*:Array*/ = manifests.reduce(function(accumulator/*:Array*/, manifest/*:Object*/)/*:Array*/ {
        var dependencies/*:Array*/ = PackageLoader.getPackageEntry(String(manifest.name)).dependencies;
        return Ext.Array.union(accumulator, dependencies);
      }, packageNames);
      return morePackageNames.length > packageNames.length
              ? PackageLoader.loadTransitiveManifests(morePackageNames)
              : PackageLoader.loadManifests(morePackageNames);
    });
  }/*

  public static*/ function loadScripts$static(packageName/*:String*/)/*:IPromise*/ {
    return PackageLoader.getPackageEntry(packageName).loadScripts();
  }/*

  public static*/ function sortByDependencies$static(packageNames/*:Array*/)/*:IPromise*/ {
    return PackageLoader.loadTransitiveManifests(packageNames).then(function()/*:Array*/ {

      function isInScope(packageName/*:String*/)/*:Boolean*/ {
        return packageNames.indexOf(packageName) !== -1;
      }

      var sortedPackages/*:Array*/ = [];
      function isSorted(packageName/*:String*/)/*:Boolean*/ {
        return sortedPackages.indexOf(packageName) !== -1;
      }

      while (sortedPackages.length < packageNames.length) {
        // find all packages that are not yet sorted, but all of their dependencies are:
        var packagesWithSortedDependencies/*:Array*/ = packageNames.filter(function(packageName/*:String*/)/*:Boolean*/ {
          return !isSorted(packageName) && // package is still unsorted and...
                  PackageLoader.getPackageEntry(packageName).dependencies.every(function(dependency/*:String*/)/*:Boolean*/ {
                    // ...all of its dependencies are either out-of-scope or already sorted:
                    return !isInScope(dependency) || isSorted(dependency);
                  });
        });

        if (packagesWithSortedDependencies.length === 0) {
          throw new AS3.Error("Inconsistent dependency graph - aborting package loading.");
        }

        // These packages have no dependencies on each other, but to end up with a reproducible load order, we sort
        // them alphabetically:
        packagesWithSortedDependencies.sort();
        sortedPackages = sortedPackages.concat(packagesWithSortedDependencies);
      }
      return sortedPackages;
    });
  }function static$0(){

  patchExtGetResourcePath$static();}/*

  private static*/ function patchExtGetResourcePath$static()/*:void*/ {
    var originalGetResourcePath/*:Function*/ =AS3.bind( Ext,"getResourcePath");
    Ext.getResourcePath = function (path/*:**/, poolName/*:String*/, packageName/*:String*/)/*:String*/ {arguments=Array.prototype.slice.call(arguments);
      if (typeof path !== 'string') {
        poolName = path.pool;
        packageName = path.packageName;
        path = path.path;
      }
      if (!poolName && "loaded" in Ext.manifest.packages[packageName]) {
        // use different resource path for dynamically loaded packages:
        return "packages/" + packageName + "/resources/" + path;
      }
      return originalGetResourcePath.apply(this, arguments);
    };
  }/*

}
}

============================================== Jangaroo part ==============================================*/
    return {
      alternateClassName: "ext.system.PackageLoader",
      statics: {
        getPackageEntry: getPackageEntry$static,
        loadPackageList: loadPackageList$static,
        loadJson: loadJson$static,
        loadManifest: loadManifest$static,
        getLoadedManifest: getLoadedManifest$static,
        loadManifests: loadManifests$static,
        loadTransitiveManifests: loadTransitiveManifests$static,
        loadScripts: loadScripts$static,
        sortByDependencies: sortByDependencies$static,
        __initStatics__: function() {
          PACKAGE_ENTRIES_BY_NAME$static_();
          static$0();
        }
      },
      requires: ["AS3.Error"],
      uses: [
        "Ext",
        "Ext.Ajax",
        "Ext.Array",
        "Ext.JSON",
        "Ext.Promise",
        "Ext.system.PackageEntry"
      ]
    };
});
